declare function rand-mrg($seed as xs:integer*) as xs:integer* {
  if (count($seed) != 2) then error("Bad seed")
  else
    (: One of the L'Ecuyer MRGs :)
    let $r := (46325 * $seed[1] + 1084587 * $seed[2]) mod 4294967295
    return ($r, $seed[1])
};