declare function sqrt($x as xs:double) as xs:double {
  (: Guess an initial value, and iterate 20 times :)
  step(20, $x * 5E-1)
};

declare function step($n as xs:integer, $x as xs:double) as xs:double {
  let $next := $x * (1.5E0 - $x * $x * $x * 5E-1)
  return if ($n <= 0) then $next else step ($n - 1, $next)
};