declare function round-up($x as xdt:anyAtomicType) {
  ceiling($x)
};

declare function round-down($x as xdt:anyAtomicType) {
  floor($x)
};

declare function round-to-zero($x as xdt:anyAtomicType) {
  if ($x > 0) then floor($x) else ceiling($x)
};

declare function round-away-from-zero($x as xdt:anyAtomicType) {
  if ($x < 0) then floor($x) else ceiling($x)
};

declare function round-half-up($x as xdt:anyAtomicType) {
  round($x)
};

declare function round-half-down($x as xdt:anyAtomicType) {
  -round(-$x)
};

declare function round-half-even($x as xdt:anyAtomicType) {
  round-half-to-even($x)
};

declare function round-half-to-zero($x as xdt:anyAtomicType) {
  if ($x > 0) then -round(-$x) else round($x)
};

declare function round-half-away-from-zero($x as xdt:anyAtomicType) {
  if ($x < 0) then -round(-$x) else round($x)
};
